import es
import hashlib
import base64
from es import server_var

# Basic cryptlib for old EventScripts addons

#plugin information
info = es.AddonInfo()
info.name = "Cryptlib EventScripts Python library"
info.version = "0.2"
info.author = "Hunter"
info.url = "http://www.eventscripts.com/pages/Cryptlib/"
info.description = "Provides basic hash functions for non-python addons"

# Basic classes
class rot13:
    def __init__(self):
        self.source = ""
    def update(self, istring):
        self.source += istring
    def copy(self):
        return rot13(self)
    def output(self):
        i = 0
        rstring = ""
        while i < len(self.source):
            x = ord(self.source[i])
            if x > 64 and x < 91:
                x += 13
                if x >= 91:
                    x -= 26
            elif x > 96 and x < 123:
                x += 13
                if x >= 123:
                    x -= 26
            rstring += chr(x)
            i += 1
        return rstring

class xor:
    def __init__(self):
        self.source = ""
        self.key = ""
    def update(self, istring):
        self.source += istring
    def setkey(self, ikey):
        self.key = ikey
    def copy(self):
        return xor(self)
    def encode(self, ikey=None):
        if ikey==None:
            ikey = self.key
        if (len(ikey) > 0):
            i = 0
            s = 0
            rstring = ""
            while i < len(self.source):
                x = ord(self.source[i])
                y = ord(ikey[s])
                x = x ^ y
                rstring += chr(x)
                i += 1
                s += 1
                if s >= len(ikey):
                    s = 0
            return rstring
        else:
            return False
    def decode(self, ikey=None):
        if ikey==None:
            ikey = self.key
        if (len(ikey) > 0):
            i = 0
            s = 0
            rstring = ""
            while i < len(self.source):
                x = ord(self.source[i])
                y = ord(ikey[s])
                x = x ^ y
                rstring += chr(x)
                i += 1
                s += 1
                if s >= len(ikey):
                    s = 0
            return rstring
        else:
            return False

class chiffre:
    def __init__(self):
        self.source = ""
        self.key = ""
    def update(self, istring):
        self.source += istring
    def setkey(self, ikey):
        self.key = ikey
    def copy(self):
        return chiffre(self)
    def encode(self, ikey=None):
        if ikey==None:
            ikey = self.key
        if (len(ikey) > 0):
            i = 0
            s = 0
            rstring = ""
            while i < len(self.source):
                x = ord(self.source[i])
                y = ord(ikey[s])
                if (x > 32) and (x < 256):
                    x += y
                    if x > 255:
                        x -= 223
                rstring += chr(x)
                i += 1
                s += 1
                if s >= len(ikey):
                    s = 0
            return rstring
        else:
            return False
    def decode(self, ikey=None):
        if ikey==None:
            ikey = self.key
        if (len(ikey) > 0):
            i = 0
            s = 0
            rstring = ""
            while i < len(self.source):
                x = ord(self.source[i])
                y = ord(ikey[s])
                if (x > 32) and (x < 256):
                    x -= y
                    if x < 33:
                        x += 223
                rstring += chr(x)
                i += 1
                s += 1
                if s >= len(ikey):
                    s = 0
            return rstring
        else:
            return False